<?php
// Inspired from yii builtin Captcha
// @author totoloco at gmail
// @site http://ushcompu.com.ar

class ETryiimathValidator extends CValidator {
  public $trymathAction='tryiimath';

  protected function validateAttribute($object,$attribute) {
    $value=$object->$attribute;
    if(($trymath=Yii::app()->getController()->createAction($this->trymathAction))===null) {
      if(strpos($this->trymathAction,'/')!==false) {
      // contains controller or module
        if(($ca=Yii::app()->createController($this->trymathAction))!==null)
        {
          list($controller,$actionID)=$ca;
          $trymath=$controller->createAction($actionID);
        }
      }
      if($trymath===null)
        throw new CException(Yii::t('yii','ETryiimathValidator.action "{id}" is invalid. Unable to find such an action in the current controller.',
            array('{id}'=>$this->trymathAction)));
    }
    if(!$trymath->validate($value)) {
      $message=$this->message!==null?$this->message:Yii::t('yii','The verification math is incorrect.');
      $this->addError($object,$attribute,$message);
    }
  }
}
